# This file contains all the small functions that are used throuhout 
# To Do: testing in loadAnnoTab, loadClusterTab
# Author: Judith Zaugg
###############################################################################


only.numeric=function(coln){
	as.numeric(sapply(strsplit(coln,'_'),'[[',1))
}
only.text=function(coln){
	if(length(grep('_',coln))>0)
	{return(as.character(sapply(strsplit(coln,'_'),'[[',2)))}
	else {return(coln)}
}

# create folder if it doesn't exist yet
createFolderIfNotExist=function(folder){
	if(!file.exists(folder)){
		system(paste("mkdir",folder)) 
		projectfoler=file.path(folder)
		return(paste('created project directory', folder,'\n'))
	}
	else{
		return(paste('using',folder,'as project folder\n'))
	}
}

loadLogFile=function(projectfolder,what,colum){
	tab=readLines(paste(projectfolder,'AGP.log',sep='/'))
	properties=sapply(strsplit(tab[grep(what,tab)],' '),'[[',colum)
	return(properties)
}


loadClusterTab=function(projectfolder,clusterTabID=NULL,force.save=FALSE){
	if(is.null(clusterTabID)){
		clusterfile=paste(projectfolder,'clusterTab.rda',sep="/")
		load(clusterfile)
		print(dim(clusterTab))
		cat('loaded anno information from',clusterfile,'\n')
	} else if(class(clusterTabID)=='character'){
		clusterfile=clusterTab
		load(clusterfile)
		cat('loaded anno information from',clusterfile,'\n')
	} else{ 
		clusterfile=paste(projectfolder,'clusterTab.rda',sep="/")
		if(!file.exists(clusterfile)|force.save){
			clusterTab=clusterTabID
			save(clusterTab,file=clusterfile)
			cat('clusterTab saved as:',clusterfile,'\n')
		} else{
			cat('clusterTab already present, file not saved.\n')
			clusterTab=clusterTabID
		}
	}
	return(clusterTab)	
}
# this is to load the annotation data file. Some more tests to be implemented!!
loadAnnoTab=function(projectfolder,annoTabID=NULL,force.save=FALSE){
	if(is.null(annoTabID)){
		annofile=paste(projectfolder,'annoTab.rda',sep="/")
		load(annofile)
		print(dim(annoTab))
		cat('loaded anno information from',annofile,'\n')
	} else if(class(annoTabID)=='character'){
		annofile=annoTab
		load(annofile)
		cat('loaded anno information from',annofile,'\n')
	} else{ 
		annofile=paste(projectfolder,'annoTab.rda',sep="/")
		if(!file.exists(annofile)|force.save){
			annoTab=annoTabID
			save(annoTab,file=annofile)
			cat('annoTab saved as:',annofile,'\n')
		} else{
			annoTab=annoTabID
			cat('annoTab already present, file not saved.\n')
		}
	}
	if(class(annoTab)=='GRanges'){
		ids=names(annoTab)
		annoTab=as.data.frame(elementMetadata(annoTab))
		annoTab$id=ids
	}
	return(annoTab)	
}

# set the lattice standards

Tset=trellis.par.get()
colores=c('blue','red','darkgreen','darkgrey','orange','black','brown')
Tset=trellis.par.get()
Tset$box.umbrella$col='black'
Tset$box.rectangle$col='black'
Tset$box.dot$col='black'
Tset$box.dot$pch=20
Tset$dot.symbol$col='black'
Tset$dot.symbol$pch='.'
Tset$plot.symbol$col='black'
Tset$box.rectangle$fill='grey'
Tset$plot.line$lwd=2
Tset$plot.symbol$pch="-"
Tset$axis.text$cex=1
Tset$par.xlab.text$cex=1
Tset$par.ylab.text$cex=1
Tset$strip.background$col='white'
Tset$superpose.line$lty=rep(1,length(Tset$superpose.line$lty))
Tset$superpose.line$lwd=rep(2,length(Tset$superpose.line$lty))
Tset$superpose.line$col=colores
Tset$superpose.symbol$col=colores
Tset$add.text$lineheight=1.5
Tset$add.text$cex=1
Tset$axis.components$top$tck=0
Tset$box.umbrella$lty=1
trellis.par.set(Tset)